#!/usr/bin/env ruby

require 'util'
require 'nkf'

@udb = get_udb

def response(msg)
  print "Content-Type: text/plain; charset=EUC-JP\r\n"
  print "Cache-Control: no-cache\r\n"
  print "Pragma: no-cache\r\n"
  print "\r\n"
  puts msg
end

def updated
end

def wait(u)
  update = @udb.transaction do
    # for reloading
    if @udb[u].key?(:pid)
      begin
        Process.kill(:HUP, @udb[u][:pid])
      rescue
      end
    end

    @udb[u][:pid] = $$
    @udb[u][:last] = Time.now
    @udb[u][:ajax] = true
    up = @udb[u][:up]
    @udb[u].delete(:up)
    sweep_timeout(@udb) || up
  end

  if update
    require 'mkdat'
    @udb.transaction do
      mkdat_udb(@udb, u)
      @udb[u].delete(:pid)
    end
    response(get_hall)
    exit 0
  end

  sleep(30)

  @udb.transaction do
    if @udb[u][:pid] == $$
      @udb[u].delete(:pid)
      @udb[u].delete(:ajax)
    end
  end
  response('no')
end

def query
  if (ENV.key?('QUERY_STRING'))
    unescape(ENV['QUERY_STRING'])
  else
    ARGV[0]
  end
end

u = safe(query)

trap(:USR1) do
  @udb.transaction do
    @udb[u].delete(:pid)
  end
  response(get_hall)
  exit 0
end

wait(u)
